#!/usr/bin/perl -w

package www;

use strict;
use Exporter;
use vars qw (@ISA @EXPORT);

@ISA = qw(Exporter);
@EXPORT = qw( 
               get_cgi_data
	    );

# ######################################################################
# my %data = read_config(<file>);
sub get_cgi_data
{

    my $query_string = '';
    my $key = '';
    my $value = '';

    # 
    # bergabewerte vom HTML auswerten 
    #
    ### GET oder POST?
    if (defined $ENV{'REQUEST_METHOD'} and $ENV{'REQUEST_METHOD'} eq
"GET")
    {
      $query_string=$ENV{'QUERY_STRING'};
    }
    elsif ((defined $ENV{'REQUEST_METHOD'} and $ENV{'REQUEST_METHOD'} eq
"POST") &&
           (defined $ENV{'CONTENT_TYPE'} and $ENV{'CONTENT_TYPE'} eq
"application/x-www-form-urlencoded"))
    {
      read(STDIN,$query_string,$ENV{'CONTENT_LENGTH'});
    }
    else
    {
      # &html_out(0,"<B>Submission method not supported!</B>\n");
      # print "<B>Submission method not supported!</B>\n";
    };
    ### Auswerten der Argumentzeilen
    my %args=();
    if ( !defined $query_string ) { $query_string = ""; }
    foreach (split(/\&/,$query_string))
    {
      $key=$value="";
      # print "$_\n";
      # if ( /^(\w+)=/ && ($key=$1) && ($value=$') )
      ( $key, $value ) = split /=/;
      # if ( /^(\w+)\=/ && ($key=$1) && ($value=$') )
      if ( defined $key and $key !~ /^\s*$/ and defined $value )
      {
        # print "$key \-\> $value =>";
        # Chaos-Zeichen wieder in das setzen, was sie sein sollen
        $value =~ s/\+/ /go;
        $value =~ s/\%([0-9a-f]{2})/pack("C",hex($1))/eig;
        if ( !defined $args{"$key"} ) { $args{"$key"} = ""; }
        $args{"$key"}=$args{"$key"} . " " . $value if ($value!~/^\s*$/);
        $args{"$key"} =~ s/^\s*//o;
        # print "$key \-\> $value\n\n";
      }
    }

    return %args;
}

# ######################################################################
1;
