#!/usr/bin/perl -w

use Crypt::RSA::Key;

my $default_size = 1024;

my %daten = ask_user();
my $identity = $daten{'identity'};
my $password = $daten{'password'};
my $size = $daten{'size'};

# my $rsa = new Crypt::RSA ( SS => 'PKCS1v15' );
my $rsa = new Crypt::RSA::Key;

			# Filename => '/tmp/neko',
			# KF => 'SSH',
my ( $public, $private ) =
     $rsa->generate (
		        Identity => $identity,
		        Size => $size,
		        Password => $password,
		        Verbosity => 1,
			Filename => '/tmp/neko'
                    ) or die $rsa->errstr();

 # $public->write( Filename => '/tmp/neko.public' );
# $private->write( Filename => '/tmp/neko.private' );

sub ask_user
{
    my %infos = ();

    # name
    print "\nYour name, please: ";
    my $name = <STDIN>; chomp $name;
    if ( $name =~ /^\s*$/ )
    { print "No name given - I can live with it\n"; }

    # email
    print "Your email, please: ";
    my $email = <STDIN>; chomp $email;
    if ( $email =~ /^\s*$/ )
    { print "No email given - I can live with it\n"; }

    # password
    print "Tell me a password, please: ";
    my $password = <STDIN>; chomp $password;

    if ( $password =~ /^\s*$/ )
    { 
        print "\nNo password given - I will choose one for you:\n"; 
	use Crypt::RandPasswd;
	$password = Crypt::RandPasswd->word( 6, 20 );
	print "Remember your new password: $password\n\n";
    }

    # key-size
    print "How long should your key be? (default: $default_size): ";
    my $size = <STDIN>; chomp $size;

    if ( $size =~ /^\s*$/ ) { $size = $default_size; }

    $infos{'identity'} = "$name <$email>";
    $infos{'password'} = $password;
    $infos{'size'} = $size;

    return %infos;
}

exit 0;
